Subject: Re: bug#70544: 30.0.50; The primitive-function "call-process-region" returns "internal error" and causes high cpu usage on win10

From: leuven65 <[email-masked]>
Date: Wed, 24 Apr 2024 10:12:10 +0200

I use the latest version "[[
https://github.com/git-for-windows/git/releases/tag/v2.44.0.windows.1]]",
in which "a couple of
bugs that could cause Git Bash to hang in certain scenarios were fixed", it
might cause the exit behavior of "gitk.exe"
changed.

The program gitk is "${git-installation-folder}/cmd/gitk.exe".

The issue only pops up when I set "(setq-default shell-file-name
"cmdproxy.exe")", if set to "bash.exe", no such
problem.

When the issue happens, emacs is not blocked, I can smoothly input in
emacs, but the cpu usage of emacs is very high
forever. As I built emacs without debug information, what I can see so far
is that most of time seems to be spent on
"MsgWaitForMultipleObjects".

I use "shell-command" (M-!) to run "gitk.exe", the correct behavior is to
run "gitk" and block emacs, or exit with
error, in my case, it prints out error "(Shell command killed by signal
internal error)" and cpu usage goes up.

>From the call stack, "shell-command" calls "call-process-region":
#+begin_quote
Debugger entered--entering a function:
,* call-process-region(324 324 "cmdproxy.exe" nil #<buffer *Shell Command
Output*> nil "-c" "gitk.exe")
  apply(call-process-region 324 324 "cmdproxy.exe" (nil #<buffer *Shell
Command Output*> nil "-c" "gitk.exe"))
  call-shell-region(324 324 "gitk.exe" nil #<buffer *Shell Command Output*>)
  shell-command-on-region(324 324 "gitk.exe" nil nil nil)
  shell-command("gitk.exe" nil nil)
  funcall-interactively(shell-command "gitk.exe" nil nil)
  command-execute(shell-command)
#+end_quote

On Wed, Apr 24, 2024 at 8:07 AM Eli Zaretskii <[email-masked]> wrote:

> > From: leuven65 <[email-masked]>
> > Date: Tue, 23 Apr 2024 20:02:39 +0200
> >
> > On windows10, I uses git for windows, but when I execute "gitk" by
> "shell-command"
> > in emacs, it returns an error "internal error",
> > and emacs's cpu usage becomes full forever, except for restarting emacs,
>
> I cannot reproduce this.  But my Git for Windows is quite old, so
> maybe newer versions made some change?  What is gitk on your machine?
> Is it a gitk.exe program or some kind of script?
>
> > The issue can be easily reproduced by directly eval following sexp:
> >
> > (call-process-region (point-min) (point-max)
> >                      "cmdproxy.exe"
> >                      t
> >                      t
> >                      nil
> >                      "-c"
> >                      "gitk")
>
> gitk is a GUI program, so why are you invoking it with
> call-process-region?  gitk will never read anything from its stdin or
> write anything to its stdout.  I suggest to invoke gitk from Emacs
> like this:
>
>   M-! gitk & RET
>
> IOW, add the "&" character at the end of the command line to make the
> invocation asynchronous, instead of letting Emacs block until gitk
> exits.
>